package com.adventurer_engine.client.model.tmt;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import atu;
import bbo;
import bbs;
import bcu;
import bgl;
import bim;
import bjo;
import com.adventurer_engine.client.model.tmt.Bone;
import com.adventurer_engine.client.model.tmt.Coord2D;
import com.adventurer_engine.client.model.tmt.ModelPool;
import com.adventurer_engine.client.model.tmt.ModelPoolEntry;
import com.adventurer_engine.client.model.tmt.PositionTextureVertex;
import com.adventurer_engine.client.model.tmt.PositionTransformVertex;
import com.adventurer_engine.client.model.tmt.Shape2D;
import com.adventurer_engine.client.model.tmt.Shape3D;
import com.adventurer_engine.client.model.tmt.TextureGroup;
import com.adventurer_engine.client.model.tmt.TexturedPolygon;
import com.adventurer_engine.client.model.tmt.TmtTessellator;
import com.adventurer_engine.client.model.tmt.TransformGroup;
import com.adventurer_engine.client.model.tmt.TransformGroupBone;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import ls;
import org.lwjgl.opengl.GL11;

public class ModelRendererTurbo extends bcu {
  private PositionTextureVertex[] vertices;
  
  private TexturedPolygon[] faces;
  
  private int r;
  
  private int s;
  
  private boolean t;
  
  private int u;
  
  private int[] displayListArray;
  
  private Map<String, TransformGroup> transformGroup;
  
  private Map<String, TextureGroup> textureGroup;
  
  private TransformGroup currentGroup;
  
  private TextureGroup currentTextureGroup;
  
  public boolean i;
  
  public boolean flip;
  
  public boolean j;
  
  public boolean field_1402_i;
  
  public boolean forcedRecompile;
  
  public boolean useLegacyCompiler;
  
  public List l;
  
  public List m;
  
  public final String n;
  
  private String defaultTexture;
  
  public static final int MR_FRONT = 0;
  
  public static final int MR_BACK = 1;
  
  public static final int MR_LEFT = 2;
  
  public static final int MR_RIGHT = 3;
  
  public static final int MR_TOP = 4;
  
  public static final int MR_BOTTOM = 5;
  
  private static final float pi = 3.1415927F;
  
  public ModelRendererTurbo(bbo modelbase, String s) {
    super(modelbase, s);
    this.flip = false;
    this.t = false;
    this.u = 0;
    this.i = false;
    this.j = true;
    this.field_1402_i = false;
    this.vertices = new PositionTextureVertex[0];
    this.faces = new TexturedPolygon[0];
    this.forcedRecompile = false;
    this.transformGroup = new HashMap<String, TransformGroup>();
    this.transformGroup.put("0", new TransformGroupBone(new Bone(0.0F, 0.0F, 0.0F, 0.0F), 1.0D));
    this.textureGroup = new HashMap<String, TextureGroup>();
    this.textureGroup.put("0", new TextureGroup());
    this.currentTextureGroup = this.textureGroup.get("0");
    this.n = s;
    this.defaultTexture = "";
    this.useLegacyCompiler = false;
  }
  
  public ModelRendererTurbo(bbo modelbase) {
    this(modelbase, null);
  }
  
  public ModelRendererTurbo(bbo modelbase, int textureX, int textureY) {
    this(modelbase, textureX, textureY, 64, 32);
  }
  
  public ModelRendererTurbo(bbo modelbase, int textureX, int textureY, int textureU, int textureV) {
    this(modelbase);
    this.r = textureX;
    this.s = textureY;
    this.a = textureU;
    this.b = textureV;
  }
  
  public void addPolygon(PositionTextureVertex[] verts) {
    copyTo(verts, new TexturedPolygon[] { new TexturedPolygon(verts) });
  }
  
  public void addPolygon(PositionTextureVertex[] verts, int[][] uv) {
    try {
      for (int i = 0; i < verts.length; i++)
        verts[i] = verts[i].setTexturePosition(uv[i][0] / this.a, uv[i][1] / this.b); 
    } finally {
      addPolygon(verts);
    } 
  }
  
  public void addPolygon(PositionTextureVertex[] verts, int u1, int v1, int u2, int v2) {
    copyTo(verts, new TexturedPolygon[] { addPolygonReturn(verts, u1, v1, u2, v2) });
  }
  
  private TexturedPolygon addPolygonReturn(PositionTextureVertex[] verts, int u1, int v1, int u2, int v2, float q1, float q2, float q3, float q4) {
    if (verts.length < 3)
      return null; 
    float uOffs = 1.0F / this.a * 10.0F;
    float vOffs = 1.0F / this.b * 10.0F;
    if (verts.length < 4) {
      float xMin = -1.0F;
      float yMin = -1.0F;
      float xMax = 0.0F;
      float yMax = 0.0F;
      for (PositionTextureVertex vert : verts) {
        float xPos = vert.b;
        float yPos = vert.c;
        xMax = Math.max(xMax, xPos);
        xMin = (xMin < -1.0F) ? xPos : Math.min(xMin, xPos);
        yMax = Math.max(yMax, yPos);
        yMin = (yMin < -1.0F) ? yPos : Math.min(yMin, yPos);
      } 
      float uMin = u1 / this.a + uOffs;
      float vMin = v1 / this.b + vOffs;
      float uSize = (u2 - u1) / this.a - uOffs * 2.0F;
      float vSize = (v2 - v1) / this.b - vOffs * 2.0F;
      float xSize = xMax - xMin;
      float ySize = yMax - yMin;
      for (int i = 0; i < verts.length; i++) {
        float xPos = (verts[i]).b;
        float yPos = (verts[i]).c;
        xPos = (xPos - xMin) / xSize;
        yPos = (yPos - yMin) / ySize;
        verts[i] = verts[i].setTexturePosition(uMin + xPos * uSize, vMin + yPos * vSize);
      } 
    } else {
      verts[0] = verts[0].setTexturePosition((u2 / this.a - uOffs) * q1, (v1 / this.b + vOffs) * q1, q1);
      verts[1] = verts[1].setTexturePosition((u1 / this.a + uOffs) * q2, (v1 / this.b + vOffs) * q2, q2);
      verts[2] = verts[2].setTexturePosition((u1 / this.a + uOffs) * q3, (v2 / this.b - vOffs) * q3, q3);
      verts[3] = verts[3].setTexturePosition((u2 / this.a - uOffs) * q4, (v2 / this.b - vOffs) * q4, q4);
    } 
    return new TexturedPolygon(verts);
  }
  
  private TexturedPolygon addPolygonReturn(PositionTextureVertex[] verts, int u1, int v1, int u2, int v2) {
    if (verts.length < 3)
      return null; 
    float uOffs = 1.0F / this.a * 10.0F;
    float vOffs = 1.0F / this.b * 10.0F;
    if (verts.length < 4) {
      float xMin = -1.0F;
      float yMin = -1.0F;
      float xMax = 0.0F;
      float yMax = 0.0F;
      for (int i = 0; i < verts.length; i++) {
        float xPos = (verts[i]).b;
        float yPos = (verts[i]).c;
        xMax = Math.max(xMax, xPos);
        xMin = (xMin < -1.0F) ? xPos : Math.min(xMin, xPos);
        yMax = Math.max(yMax, yPos);
        yMin = (yMin < -1.0F) ? yPos : Math.min(yMin, yPos);
      } 
      float uMin = u1 / this.a + uOffs;
      float vMin = v1 / this.b + vOffs;
      float uSize = (u2 - u1) / this.a - uOffs * 2.0F;
      float vSize = (v2 - v1) / this.b - vOffs * 2.0F;
      float xSize = xMax - xMin;
      float ySize = yMax - yMin;
      for (int j = 0; j < verts.length; j++) {
        float xPos = (verts[j]).b;
        float yPos = (verts[j]).c;
        xPos = (xPos - xMin) / xSize;
        yPos = (yPos - yMin) / ySize;
        verts[j] = verts[j].setTexturePosition(uMin + xPos * uSize, vMin + yPos * vSize);
      } 
    } else {
      verts[0] = verts[0].setTexturePosition(u2 / this.a - uOffs, v1 / this.b + vOffs);
      verts[1] = verts[1].setTexturePosition(u1 / this.a + uOffs, v1 / this.b + vOffs);
      verts[2] = verts[2].setTexturePosition(u1 / this.a + uOffs, v2 / this.b - vOffs);
      verts[3] = verts[3].setTexturePosition(u2 / this.a - uOffs, v2 / this.b - vOffs);
    } 
    return new TexturedPolygon(verts);
  }
  
  public void addRectShape(float[] v, float[] v1, float[] v2, float[] v3, float[] v4, float[] v5, float[] v6, float[] v7, int w, int h, int d) {
    float[] var1 = { 
        1.0F, 1.0F, 1.0F, 1.0F, 1.0F, 1.0F, 1.0F, 1.0F, 1.0F, 1.0F, 
        1.0F, 1.0F };
    addRectShape(v, v1, v2, v3, v4, v5, v6, v7, w, h, d, var1);
  }
  
  public void addRectShape(float[] v, float[] v1, float[] v2, float[] v3, float[] v4, float[] v5, float[] v6, float[] v7, int w, int h, int d, float[] qParam) {
    PositionTextureVertex[] verts = new PositionTextureVertex[8];
    TexturedPolygon[] poly = new TexturedPolygon[6];
    PositionTextureVertex pv0 = new PositionTextureVertex(v[0], v[1], v[2], 0.0F, 0.0F);
    PositionTextureVertex pv1 = new PositionTextureVertex(v1[0], v1[1], v1[2], 0.0F, 8.0F);
    PositionTextureVertex pv2 = new PositionTextureVertex(v2[0], v2[1], v2[2], 8.0F, 8.0F);
    PositionTextureVertex pv3 = new PositionTextureVertex(v3[0], v3[1], v3[2], 8.0F, 0.0F);
    PositionTextureVertex pv4 = new PositionTextureVertex(v4[0], v4[1], v4[2], 0.0F, 0.0F);
    PositionTextureVertex Pv5 = new PositionTextureVertex(v5[0], v5[1], v5[2], 0.0F, 8.0F);
    PositionTextureVertex pv6 = new PositionTextureVertex(v6[0], v6[1], v6[2], 8.0F, 8.0F);
    PositionTextureVertex pv7 = new PositionTextureVertex(v7[0], v7[1], v7[2], 8.0F, 0.0F);
    verts[0] = pv0;
    verts[1] = pv1;
    verts[2] = pv2;
    verts[3] = pv3;
    verts[4] = pv4;
    verts[5] = Pv5;
    verts[6] = pv6;
    verts[7] = pv7;
    poly[0] = addPolygonReturn(new PositionTextureVertex[] { Pv5, pv1, pv2, pv6 }, this.r + d + w, this.s + d, this.r + d + w + d, this.s + d + h, 1.0F, qParam[7], qParam[10] * qParam[7], qParam[10]);
    poly[1] = addPolygonReturn(new PositionTextureVertex[] { pv0, pv4, pv7, pv3 }, this.r + 0, this.s + d, this.r + d, this.s + d + h, qParam[9] * qParam[6], qParam[9], 1.0F, qParam[6]);
    poly[2] = addPolygonReturn(new PositionTextureVertex[] { Pv5, pv4, pv0, pv1 }, this.r + d, this.s + 0, this.r + d + w, this.s + d, 1.0F, qParam[8], qParam[1] * qParam[8], qParam[1]);
    poly[3] = addPolygonReturn(new PositionTextureVertex[] { pv2, pv3, pv7, pv6 }, this.r + d + w, this.s + 0, this.r + d + w + w, this.s + d, qParam[3], qParam[3] * qParam[11], qParam[11], 1.0F);
    poly[4] = addPolygonReturn(new PositionTextureVertex[] { pv1, pv0, pv3, pv2 }, this.r + d, this.s + d, this.r + d + w, this.s + d + h, qParam[0], qParam[0] * qParam[4], qParam[4], 1.0F);
    poly[5] = addPolygonReturn(new PositionTextureVertex[] { pv4, Pv5, pv6, pv7 }, this.r + d + w + d, this.s + d, this.r + d + w + d + w, this.s + d + h, qParam[2] * qParam[5], qParam[2], 1.0F, qParam[5]);
    if ((this.i ^ this.flip) != 0)
      for (TexturedPolygon texturedPolygon : poly)
        texturedPolygon.flipFace();  
    copyTo(verts, poly);
  }
  
  public com.adventurer_engine.client.model.tmt.ModelRendererTurbo addBox(float x, float y, float z, int xe, int ye, int ze) {
    a(x, y, z, xe, ye, ze, 0.0F);
    return this;
  }
  
  public void a(float x, float y, float z, int w, int h, int d, float expansion) {
    addBox(x, y, z, w, h, d, expansion, 1.0F);
  }
  
  public void addBox(float x, float y, float z, int w, int h, int d, float expansion, float scale) {
    float scaleX = w * scale;
    float scaleY = h * scale;
    float scaleZ = d * scale;
    float x1 = x + scaleX;
    float y1 = y + scaleY;
    float z1 = z + scaleZ;
    float expX = expansion + scaleX - w;
    float expY = expansion + scaleY - h;
    float expZ = expansion + scaleZ - d;
    x -= expX;
    y -= expY;
    z -= expZ;
    x1 += expansion;
    y1 += expansion;
    z1 += expansion;
    if (this.i) {
      float xTemp = x1;
      x1 = x;
      x = xTemp;
    } 
    float[] v = { x, y, z };
    float[] v1 = { x1, y, z };
    float[] v2 = { x1, y1, z };
    float[] v3 = { x, y1, z };
    float[] v4 = { x, y, z1 };
    float[] v5 = { x1, y, z1 };
    float[] v6 = { x1, y1, z1 };
    float[] v7 = { x, y1, z1 };
    addRectShape(v, v1, v2, v3, v4, v5, v6, v7, w, h, d);
  }
  
  public void addTrapezoid(float x, float y, float z, int w, int h, int d, float scale, float bottomScale, int dir) {
    float f4 = x + w;
    float f5 = y + h;
    float f6 = z + d;
    x -= scale;
    y -= scale;
    z -= scale;
    f4 += scale;
    f5 += scale;
    f6 += scale;
    int m = this.i ? -1 : 1;
    if (this.i) {
      float f7 = f4;
      f4 = x;
      x = f7;
    } 
    float[] v = { x, y, z };
    float[] v1 = { f4, y, z };
    float[] v2 = { f4, f5, z };
    float[] v3 = { x, f5, z };
    float[] v4 = { x, y, f6 };
    float[] v5 = { f4, y, f6 };
    float[] v6 = { f4, f5, f6 };
    float[] v7 = { x, f5, f6 };
    switch (dir) {
      case 3:
        v[1] = v[1] - bottomScale;
        v[2] = v[2] - bottomScale;
        v3[1] = v3[1] + bottomScale;
        v3[2] = v3[2] - bottomScale;
        v4[1] = v4[1] - bottomScale;
        v4[2] = v4[2] + bottomScale;
        v7[1] = v7[1] + bottomScale;
        v7[2] = v7[2] + bottomScale;
        break;
      case 2:
        v1[1] = v1[1] - bottomScale;
        v1[2] = v1[2] - bottomScale;
        v2[1] = v2[1] + bottomScale;
        v2[2] = v2[2] - bottomScale;
        v5[1] = v5[1] - bottomScale;
        v5[2] = v5[2] + bottomScale;
        v6[1] = v6[1] + bottomScale;
        v6[2] = v6[2] + bottomScale;
        break;
      case 0:
        v[0] = v[0] - m * bottomScale;
        v[1] = v[1] - bottomScale;
        v1[0] = v1[0] + m * bottomScale;
        v1[1] = v1[1] - bottomScale;
        v2[0] = v2[0] + m * bottomScale;
        v2[1] = v2[1] + bottomScale;
        v3[0] = v3[0] - m * bottomScale;
        v3[1] = v3[1] + bottomScale;
        break;
      case 1:
        v4[0] = v4[0] - m * bottomScale;
        v4[1] = v4[1] - bottomScale;
        v5[0] = v5[0] + m * bottomScale;
        v5[1] = v5[1] - bottomScale;
        v6[0] = v6[0] + m * bottomScale;
        v6[1] = v6[1] + bottomScale;
        v7[0] = v7[0] - m * bottomScale;
        v7[1] = v7[1] + bottomScale;
        break;
      case 4:
        v[0] = v[0] - m * bottomScale;
        v[2] = v[2] - bottomScale;
        v1[0] = v1[0] + m * bottomScale;
        v1[2] = v1[2] - bottomScale;
        v4[0] = v4[0] - m * bottomScale;
        v4[2] = v4[2] + bottomScale;
        v5[0] = v5[0] + m * bottomScale;
        v5[2] = v5[2] + bottomScale;
        break;
      case 5:
        v2[0] = v2[0] + m * bottomScale;
        v2[2] = v2[2] - bottomScale;
        v3[0] = v3[0] - m * bottomScale;
        v3[2] = v3[2] - bottomScale;
        v6[0] = v6[0] + m * bottomScale;
        v6[2] = v6[2] + bottomScale;
        v7[0] = v7[0] - m * bottomScale;
        v7[2] = v7[2] + bottomScale;
        break;
    } 
    float[] qValues = { 
        Math.abs((v[0] - v1[0]) / (v3[0] - v2[0])), Math.abs((v[0] - v1[0]) / (v4[0] - v5[0])), Math.abs((v4[0] - v5[0]) / (v7[0] - v6[0])), Math.abs((v3[0] - v2[0]) / (v7[0] - v6[0])), Math.abs((v[1] - v3[1]) / (v1[1] - v2[1])), Math.abs((v4[1] - v7[1]) / (v5[1] - v6[1])), Math.abs((v[1] - v3[1]) / (v4[1] - v7[1])), Math.abs((v1[1] - v2[1]) / (v5[1] - v6[1])), Math.abs((v[2] - v4[2]) / (v1[2] - v5[2])), Math.abs((v[2] - v4[2]) / (v3[2] - v7[2])), 
        Math.abs((v1[2] - v5[2]) / (v2[2] - v6[2])), Math.abs((v3[2] - v7[2]) / (v2[2] - v6[2])) };
    addRectShape(v, v1, v2, v3, v4, v5, v6, v7, w, h, d, qValues);
  }
  
  public void addFlexBox(float x, float y, float z, int w, int h, int d, float scale, float bScale1, float bScale2, float bScale3, float bScale4, int dir) {
    float f4 = x + w;
    float f5 = y + h;
    float f6 = z + d;
    x -= scale;
    y -= scale;
    z -= scale;
    f4 += scale;
    f5 += scale;
    f6 += scale;
    int m = this.i ? -1 : 1;
    if (this.i) {
      float f7 = f4;
      f4 = x;
      x = f7;
    } 
    float[] v = { x, y, z };
    float[] v1 = { f4, y, z };
    float[] v2 = { f4, f5, z };
    float[] v3 = { x, f5, z };
    float[] v4 = { x, y, f6 };
    float[] v5 = { f4, y, f6 };
    float[] v6 = { f4, f5, f6 };
    float[] v7 = { x, f5, f6 };
    switch (dir) {
      case 3:
        v[1] = v[1] - bScale1;
        v[2] = v[2] - bScale3;
        v3[1] = v3[1] + bScale2;
        v3[2] = v3[2] - bScale3;
        v4[1] = v4[1] - bScale1;
        v4[2] = v4[2] + bScale4;
        v7[1] = v7[1] + bScale2;
        v7[2] = v7[2] + bScale4;
        break;
      case 2:
        v1[1] = v1[1] - bScale1;
        v1[2] = v1[2] - bScale3;
        v2[1] = v2[1] + bScale2;
        v2[2] = v2[2] - bScale3;
        v5[1] = v5[1] - bScale1;
        v5[2] = v5[2] + bScale4;
        v6[1] = v6[1] + bScale2;
        v6[2] = v6[2] + bScale4;
        break;
      case 0:
        v[0] = v[0] - m * bScale4;
        v[1] = v[1] - bScale1;
        v1[0] = v1[0] + m * bScale3;
        v1[1] = v1[1] - bScale1;
        v2[0] = v2[0] + m * bScale3;
        v2[1] = v2[1] + bScale2;
        v3[0] = v3[0] - m * bScale4;
        v3[1] = v3[1] + bScale2;
        break;
      case 1:
        v4[0] = v4[0] - m * bScale4;
        v4[1] = v4[1] - bScale1;
        v5[0] = v5[0] + m * bScale3;
        v5[1] = v5[1] - bScale1;
        v6[0] = v6[0] + m * bScale3;
        v6[1] = v6[1] + bScale2;
        v7[0] = v7[0] - m * bScale4;
        v7[1] = v7[1] + bScale2;
        break;
      case 4:
        v[0] = v[0] - m * bScale1;
        v[2] = v[2] - bScale3;
        v1[0] = v1[0] + m * bScale2;
        v1[2] = v1[2] - bScale3;
        v4[0] = v4[0] - m * bScale1;
        v4[2] = v4[2] + bScale4;
        v5[0] = v5[0] + m * bScale2;
        v5[2] = v5[2] + bScale4;
        break;
      case 5:
        v2[0] = v2[0] + m * bScale2;
        v2[2] = v2[2] - bScale3;
        v3[0] = v3[0] - m * bScale1;
        v3[2] = v3[2] - bScale3;
        v6[0] = v6[0] + m * bScale2;
        v6[2] = v6[2] + bScale4;
        v7[0] = v7[0] - m * bScale1;
        v7[2] = v7[2] + bScale4;
        break;
    } 
    float[] qValues = { 
        Math.abs((v[0] - v1[0]) / (v3[0] - v2[0])), Math.abs((v[0] - v1[0]) / (v4[0] - v5[0])), Math.abs((v4[0] - v5[0]) / (v7[0] - v6[0])), Math.abs((v3[0] - v2[0]) / (v7[0] - v6[0])), Math.abs((v[1] - v3[1]) / (v1[1] - v2[1])), Math.abs((v4[1] - v7[1]) / (v5[1] - v6[1])), Math.abs((v[1] - v3[1]) / (v4[1] - v7[1])), Math.abs((v1[1] - v2[1]) / (v5[1] - v6[1])), Math.abs((v[2] - v4[2]) / (v1[2] - v5[2])), Math.abs((v[2] - v4[2]) / (v3[2] - v7[2])), 
        Math.abs((v1[2] - v5[2]) / (v2[2] - v6[2])), Math.abs((v3[2] - v7[2]) / (v2[2] - v6[2])) };
    addRectShape(v, v1, v2, v3, v4, v5, v6, v7, w, h, d, qValues);
  }
  
  public void addFlexTrapezoid(float x, float y, float z, int w, int h, int d, float scale, float bScale1, float bScale2, float bScale3, float bScale4, float fScale1, float fScale2, int dir) {
    float f4 = x + w;
    float f5 = y + h;
    float f6 = z + d;
    x -= scale;
    y -= scale;
    z -= scale;
    f4 += scale;
    f5 += scale;
    f6 += scale;
    int m = this.i ? -1 : 1;
    if (this.i) {
      float f7 = f4;
      f4 = x;
      x = f7;
    } 
    float[] v = { x, y, z };
    float[] v1 = { f4, y, z };
    float[] v2 = { f4, f5, z };
    float[] v3 = { x, f5, z };
    float[] v4 = { x, y, f6 };
    float[] v5 = { f4, y, f6 };
    float[] v6 = { f4, f5, f6 };
    float[] v7 = { x, f5, f6 };
    switch (dir) {
      case 3:
        v[2] = v[2] - fScale1;
        v1[2] = v1[2] - fScale1;
        v4[2] = v4[2] + fScale2;
        v5[2] = v5[2] + fScale2;
        v[1] = v[1] - bScale1;
        v[2] = v[2] - bScale3;
        v3[1] = v3[1] + bScale2;
        v3[2] = v3[2] - bScale3;
        v4[1] = v4[1] - bScale1;
        v4[2] = v4[2] + bScale4;
        v7[1] = v7[1] + bScale2;
        v7[2] = v7[2] + bScale4;
        break;
      case 2:
        v[2] = v[2] - fScale1;
        v1[2] = v1[2] - fScale1;
        v4[2] = v4[2] + fScale2;
        v5[2] = v5[2] + fScale2;
        v1[1] = v1[1] - bScale1;
        v1[2] = v1[2] - bScale3;
        v2[1] = v2[1] + bScale2;
        v2[2] = v2[2] - bScale3;
        v5[1] = v5[1] - bScale1;
        v5[2] = v5[2] + bScale4;
        v6[1] = v6[1] + bScale2;
        v6[2] = v6[2] + bScale4;
        break;
      case 0:
        v1[1] = v1[1] - fScale1;
        v5[1] = v5[1] - fScale1;
        v2[1] = v2[1] + fScale2;
        v6[1] = v6[1] + fScale2;
        v[0] = v[0] - m * bScale4;
        v[1] = v[1] - bScale1;
        v1[0] = v1[0] + m * bScale3;
        v1[1] = v1[1] - bScale1;
        v2[0] = v2[0] + m * bScale3;
        v2[1] = v2[1] + bScale2;
        v3[0] = v3[0] - m * bScale4;
        v3[1] = v3[1] + bScale2;
        break;
      case 1:
        v1[1] = v1[1] - fScale1;
        v5[1] = v5[1] - fScale1;
        v2[1] = v2[1] + fScale2;
        v6[1] = v6[1] + fScale2;
        v4[0] = v4[0] - m * bScale4;
        v4[1] = v4[1] - bScale1;
        v5[0] = v5[0] + m * bScale3;
        v5[1] = v5[1] - bScale1;
        v6[0] = v6[0] + m * bScale3;
        v6[1] = v6[1] + bScale2;
        v7[0] = v7[0] - m * bScale4;
        v7[1] = v7[1] + bScale2;
        break;
      case 4:
        v1[2] = v1[2] - fScale1;
        v2[2] = v2[2] - fScale1;
        v5[2] = v5[2] + fScale2;
        v6[2] = v6[2] + fScale2;
        v[0] = v[0] - m * bScale1;
        v[2] = v[2] - bScale3;
        v1[0] = v1[0] + m * bScale2;
        v1[2] = v1[2] - bScale3;
        v4[0] = v4[0] - m * bScale1;
        v4[2] = v4[2] + bScale4;
        v5[0] = v5[0] + m * bScale2;
        v5[2] = v5[2] + bScale4;
        break;
      case 5:
        v1[2] = v1[2] - fScale1;
        v2[2] = v2[2] - fScale1;
        v5[2] = v5[2] + fScale2;
        v6[2] = v6[2] + fScale2;
        v2[0] = v2[0] + m * bScale2;
        v2[2] = v2[2] - bScale3;
        v3[0] = v3[0] - m * bScale1;
        v3[2] = v3[2] - bScale3;
        v6[0] = v6[0] + m * bScale2;
        v6[2] = v6[2] + bScale4;
        v7[0] = v7[0] - m * bScale1;
        v7[2] = v7[2] + bScale4;
        break;
    } 
    float[] qValues = { 
        Math.abs((v[0] - v1[0]) / (v3[0] - v2[0])), Math.abs((v[0] - v1[0]) / (v4[0] - v5[0])), Math.abs((v4[0] - v5[0]) / (v7[0] - v6[0])), Math.abs((v3[0] - v2[0]) / (v7[0] - v6[0])), Math.abs((v[1] - v3[1]) / (v1[1] - v2[1])), Math.abs((v4[1] - v7[1]) / (v5[1] - v6[1])), Math.abs((v[1] - v3[1]) / (v4[1] - v7[1])), Math.abs((v1[1] - v2[1]) / (v5[1] - v6[1])), Math.abs((v[2] - v4[2]) / (v1[2] - v5[2])), Math.abs((v[2] - v4[2]) / (v3[2] - v7[2])), 
        Math.abs((v1[2] - v5[2]) / (v2[2] - v6[2])), Math.abs((v3[2] - v7[2]) / (v2[2] - v6[2])) };
    addRectShape(v, v1, v2, v3, v4, v5, v6, v7, w, h, d, qValues);
  }
  
  public void addBox(float x, float y, float z, float w, float h, float d) {
    int rw = ls.f(w);
    int rh = ls.f(h);
    int rd = ls.f(d);
    w -= rw;
    h -= rh;
    d -= rd;
    addShapeBox(x, y, z, rw, rh, rd, 0.0F, 0.0F, 0.0F, 0.0F, w, 0.0F, 0.0F, w, 0.0F, d, 0.0F, 0.0F, d, 0.0F, h, 0.0F, w, h, 0.0F, w, h, d, 0.0F, h, d);
  }
  
  public void addShapeBox(float x, float y, float z, int w, int h, int d, float scale, float x0, float y0, float z0, float x1, float y1, float z1, float x2, float y2, float z2, float x3, float y3, float z3, float x4, float y4, float z4, float x5, float y5, float z5, float x6, float y6, float z6, float x7, float y7, float z7) {
    float f4 = x + w;
    float f5 = y + h;
    float f6 = z + d;
    x -= scale;
    y -= scale;
    z -= scale;
    f4 += scale;
    f5 += scale;
    f6 += scale;
    int m = this.i ? -1 : 1;
    if (this.i) {
      float f7 = f4;
      f4 = x;
      x = f7;
    } 
    float[] v = { x - x0, y - y0, z - z0 };
    float[] v1 = { f4 + x1, y - y1, z - z1 };
    float[] v2 = { f4 + x5, f5 + y5, z - z5 };
    float[] v3 = { x - x4, f5 + y4, z - z4 };
    float[] v4 = { x - x3, y - y3, f6 + z3 };
    float[] v5 = { f4 + x2, y - y2, f6 + z2 };
    float[] v6 = { f4 + x6, f5 + y6, f6 + z6 };
    float[] v7 = { x - x7, f5 + y7, f6 + z7 };
    float[] qValues = { 
        Math.abs((v[0] - v1[0]) / (v3[0] - v2[0])), Math.abs((v[0] - v1[0]) / (v4[0] - v5[0])), Math.abs((v4[0] - v5[0]) / (v7[0] - v6[0])), Math.abs((v3[0] - v2[0]) / (v7[0] - v6[0])), Math.abs((v[1] - v3[1]) / (v1[1] - v2[1])), Math.abs((v4[1] - v7[1]) / (v5[1] - v6[1])), Math.abs((v[1] - v3[1]) / (v4[1] - v7[1])), Math.abs((v1[1] - v2[1]) / (v5[1] - v6[1])), Math.abs((v[2] - v4[2]) / (v1[2] - v5[2])), Math.abs((v[2] - v4[2]) / (v3[2] - v7[2])), 
        Math.abs((v1[2] - v5[2]) / (v2[2] - v6[2])), Math.abs((v3[2] - v7[2]) / (v2[2] - v6[2])) };
    addRectShape(v, v1, v2, v3, v4, v5, v6, v7, w, h, d, qValues);
  }
  
  public void addShape3D(float x, float y, float z, Coord2D[] coordinates, float depth, int shapeTextureWidth, int shapeTextureHeight, int sideTextureWidth, int sideTextureHeight, int direction) {
    addShape3D(x, y, z, coordinates, depth, shapeTextureWidth, shapeTextureHeight, sideTextureWidth, sideTextureHeight, direction, null);
  }
  
  public void addShape3D(float x, float y, float z, Coord2D[] coordinates, float depth, int shapeTextureWidth, int shapeTextureHeight, int sideTextureWidth, int sideTextureHeight, int direction, float[] faceLengths) {
    addShape3D(x, y, z, new Shape2D(coordinates), depth, shapeTextureWidth, shapeTextureHeight, sideTextureWidth, sideTextureHeight, direction, faceLengths);
  }
  
  public void addShape3D(float x, float y, float z, ArrayList<Coord2D> coordinates, float depth, int shapeTextureWidth, int shapeTextureHeight, int sideTextureWidth, int sideTextureHeight, int direction) {
    addShape3D(x, y, z, coordinates, depth, shapeTextureWidth, shapeTextureHeight, sideTextureWidth, sideTextureHeight, direction, null);
  }
  
  public void addShape3D(float x, float y, float z, ArrayList<Coord2D> coordinates, float depth, int shapeTextureWidth, int shapeTextureHeight, int sideTextureWidth, int sideTextureHeight, int direction, float[] faceLengths) {
    addShape3D(x, y, z, new Shape2D(coordinates), depth, shapeTextureWidth, shapeTextureHeight, sideTextureWidth, sideTextureHeight, direction, faceLengths);
  }
  
  public void addShape3D(float x, float y, float z, Shape2D shape, float depth, int shapeTextureWidth, int shapeTextureHeight, int sideTextureWidth, int sideTextureHeight, int direction) {
    addShape3D(x, y, z, shape, depth, shapeTextureWidth, shapeTextureHeight, sideTextureWidth, sideTextureHeight, direction, null);
  }
  
  public void addShape3D(float x, float y, float z, Shape2D shape, float depth, int shapeTextureWidth, int shapeTextureHeight, int sideTextureWidth, int sideTextureHeight, int direction, float[] faceLengths) {
    float rotX = 0.0F;
    float rotY = 0.0F;
    float rotZ = 0.0F;
    switch (direction) {
      case 2:
        rotY = 1.5707964F;
        break;
      case 3:
        rotY = -1.5707964F;
        break;
      case 4:
        rotX = 1.5707964F;
        break;
      case 5:
        rotX = -1.5707964F;
        break;
      case 0:
        rotY = 3.1415927F;
        break;
    } 
    addShape3D(x, y, z, shape, depth, shapeTextureWidth, shapeTextureHeight, sideTextureWidth, sideTextureHeight, rotX, rotY, rotZ, faceLengths);
  }
  
  public void addShape3D(float x, float y, float z, Shape2D shape, float depth, int shapeTextureWidth, int shapeTextureHeight, int sideTextureWidth, int sideTextureHeight, float rotX, float rotY, float rotZ) {
    addShape3D(x, y, z, shape, depth, shapeTextureWidth, shapeTextureHeight, sideTextureWidth, sideTextureHeight, rotX, rotY, rotZ, null);
  }
  
  public void addShape3D(float x, float y, float z, Shape2D shape, float depth, int shapeTextureWidth, int shapeTextureHeight, int sideTextureWidth, int sideTextureHeight, float rotX, float rotY, float rotZ, float[] faceLengths) {
    Shape3D shape3D = shape.extrude(x, y, z, rotX, rotY, rotZ, depth, this.r, this.s, this.a, this.b, shapeTextureWidth, shapeTextureHeight, sideTextureWidth, sideTextureHeight, faceLengths);
    if (this.flip)
      for (int idx = 0; idx < shape3D.faces.length; idx++)
        shape3D.faces[idx].flipFace();  
    copyTo((PositionTextureVertex[])shape3D.vertices, shape3D.faces);
  }
  
  public void addPixel(float x, float y, float z, float width, float height, float length) {
    addPixel(x, y, z, new float[] { width, height, length }, this.r, this.s);
  }
  
  public void addPixel(float x, float y, float z, float[] scale, int w, int h) {
    PositionTextureVertex[] verts = new PositionTextureVertex[8];
    TexturedPolygon[] poly = new TexturedPolygon[6];
    float x1 = x + scale[0];
    float y1 = y + scale[1];
    float z1 = z + scale[2];
    float[] f = { x, y, z };
    float[] f1 = { x1, y, z };
    float[] f2 = { x1, y1, z };
    float[] f3 = { x, y1, z };
    float[] f4 = { x, y, z1 };
    float[] f5 = { x1, y, z1 };
    float[] f6 = { x1, y1, z1 };
    float[] f7 = { x, y1, z1 };
    PositionTextureVertex positionTexturevertex = new PositionTextureVertex(f[0], f[1], f[2], 0.0F, 0.0F);
    PositionTextureVertex positionTexturevertex1 = new PositionTextureVertex(f1[0], f1[1], f1[2], 0.0F, 8.0F);
    PositionTextureVertex positionTexturevertex2 = new PositionTextureVertex(f2[0], f2[1], f2[2], 8.0F, 8.0F);
    PositionTextureVertex positionTexturevertex3 = new PositionTextureVertex(f3[0], f3[1], f3[2], 8.0F, 0.0F);
    PositionTextureVertex positionTexturevertex4 = new PositionTextureVertex(f4[0], f4[1], f4[2], 0.0F, 0.0F);
    PositionTextureVertex positionTexturevertex5 = new PositionTextureVertex(f5[0], f5[1], f5[2], 0.0F, 8.0F);
    PositionTextureVertex positionTexturevertex6 = new PositionTextureVertex(f6[0], f6[1], f6[2], 8.0F, 8.0F);
    PositionTextureVertex positionTexturevertex7 = new PositionTextureVertex(f7[0], f7[1], f7[2], 8.0F, 0.0F);
    verts[0] = positionTexturevertex;
    verts[1] = positionTexturevertex1;
    verts[2] = positionTexturevertex2;
    verts[3] = positionTexturevertex3;
    verts[4] = positionTexturevertex4;
    verts[5] = positionTexturevertex5;
    verts[6] = positionTexturevertex6;
    verts[7] = positionTexturevertex7;
    poly[0] = addPolygonReturn(new PositionTextureVertex[] { positionTexturevertex5, positionTexturevertex1, positionTexturevertex2, positionTexturevertex6 }, w, h, w + 1, h + 1);
    poly[1] = addPolygonReturn(new PositionTextureVertex[] { positionTexturevertex, positionTexturevertex4, positionTexturevertex7, positionTexturevertex3 }, w, h, w + 1, h + 1);
    poly[2] = addPolygonReturn(new PositionTextureVertex[] { positionTexturevertex5, positionTexturevertex4, positionTexturevertex, positionTexturevertex1 }, w, h, w + 1, h + 1);
    poly[3] = addPolygonReturn(new PositionTextureVertex[] { positionTexturevertex2, positionTexturevertex3, positionTexturevertex7, positionTexturevertex6 }, w, h, w + 1, h + 1);
    poly[4] = addPolygonReturn(new PositionTextureVertex[] { positionTexturevertex1, positionTexturevertex, positionTexturevertex3, positionTexturevertex2 }, w, h, w + 1, h + 1);
    poly[5] = addPolygonReturn(new PositionTextureVertex[] { positionTexturevertex4, positionTexturevertex5, positionTexturevertex6, positionTexturevertex7 }, w, h, w + 1, h + 1);
    copyTo(verts, poly);
  }
  
  public void addSprite(float x, float y, float z, int w, int h, float expansion) {
    addSprite(x, y, z, w, h, 1, false, false, false, false, false, expansion);
  }
  
  public void addSprite(float x, float y, float z, int w, int h, boolean rotX, boolean rotY, boolean rotZ, boolean mirrorX, boolean mirrorY, float expansion) {
    addSprite(x, y, z, w, h, 1, rotX, rotY, rotZ, mirrorX, mirrorY, expansion);
  }
  
  public void addSprite(float x, float y, float z, int w, int h, int d, boolean rotX, boolean rotY, boolean rotZ, boolean mirrorX, boolean mirrorY, float expansion) {
    addSprite(x, y, z, w, h, d, 1.0F, rotX, rotY, rotZ, mirrorX, mirrorY, expansion);
  }
  
  public void addSprite(float x, float y, float z, int w, int h, int d, float pixelScale, boolean rotX, boolean rotY, boolean rotZ, boolean mirrorX, boolean mirrorY, float expansion) {
    String[] mask = new String[h];
    char[] str = new char[w];
    Arrays.fill(str, '1');
    Arrays.fill((Object[])mask, new String(str));
    addSprite(x, y, z, mask, d, pixelScale, rotX, rotY, rotZ, mirrorX, mirrorY, expansion);
  }
  
  public void addSprite(float x, float y, float z, String[] mask, int d, float pixelScale, boolean rotX, boolean rotY, boolean rotZ, boolean mirrorX, boolean mirrorY, float expansion) {
    int w = mask[0].length();
    int h = mask.length;
    float x1 = x - expansion;
    float y1 = y - expansion;
    float z1 = z - expansion;
    int wDir = 0;
    int hDir = 0;
    int dDir = 0;
    float wScale = 1.0F + expansion / w * pixelScale;
    float hScale = 1.0F + expansion / h * pixelScale;
    if (!rotX) {
      if (!rotY) {
        if (!rotZ) {
          wDir = 0;
          hDir = 1;
          dDir = 2;
        } else {
          wDir = 1;
          hDir = 0;
          dDir = 2;
        } 
      } else if (!rotZ) {
        wDir = 2;
        hDir = 1;
        dDir = 0;
      } else {
        wDir = 2;
        hDir = 0;
        dDir = 1;
      } 
    } else if (!rotY) {
      if (!rotZ) {
        wDir = 0;
        hDir = 2;
        dDir = 1;
      } else {
        wDir = 1;
        hDir = 2;
        dDir = 0;
      } 
    } else if (!rotZ) {
      wDir = 2;
      hDir = 0;
      dDir = 1;
    } else {
      wDir = 2;
      hDir = 1;
      dDir = 0;
    } 
    int texStartX = this.r + (mirrorX ? (w * 1 - 1) : 0);
    int texStartY = this.s + (mirrorY ? (h * 1 - 1) : 0);
    int texDirX = mirrorX ? -1 : 1;
    int texDirY = mirrorY ? -1 : 1;
    float wVoxSize = getPixelSize(wScale, hScale, d * pixelScale + expansion * 2.0F, 0, 1, wDir, 1, 1);
    float hVoxSize = getPixelSize(wScale, hScale, d * pixelScale + expansion * 2.0F, 0, 1, hDir, 1, 1);
    float dVoxSize = getPixelSize(wScale, hScale, d * pixelScale + expansion * 2.0F, 0, 1, dDir, 1, 1);
    for (int i = 0; i < w; i++) {
      for (int j = 0; j < h; j++) {
        if (mask[j].charAt(i) == '1')
          addPixel(x1 + getPixelSize(wScale, hScale, 0.0F, wDir, hDir, 0, i, j), y1 + getPixelSize(wScale, hScale, 0.0F, wDir, hDir, 1, i, j), z1 + getPixelSize(wScale, hScale, 0.0F, wDir, hDir, 2, i, j), new float[] { wVoxSize, hVoxSize, dVoxSize }, texStartX + texDirX * i, texStartY + texDirY * j); 
      } 
    } 
  }
  
  private float getPixelSize(float wScale, float hScale, float dScale, int wDir, int hDir, int checkDir, int texPosX, int texPosY) {
    return (wDir == checkDir) ? (wScale * texPosX) : ((hDir == checkDir) ? (hScale * texPosY) : dScale);
  }
  
  public void addSphere(float x, float y, float z, float r, int segs, int rings, int textureW, int textureH) {
    if (segs < 3)
      segs = 3; 
    rings++;
    PositionTextureVertex[] tempVerts = new PositionTextureVertex[segs * (rings - 1) + 2];
    TexturedPolygon[] poly = new TexturedPolygon[segs * rings];
    tempVerts[0] = new PositionTextureVertex(x, y - r, z, 0.0F, 0.0F);
    tempVerts[tempVerts.length - 1] = new PositionTextureVertex(x, y + r, z, 0.0F, 0.0F);
    float uOffs = 1.0F / this.a * 10.0F;
    float vOffs = 1.0F / this.b * 10.0F;
    float texW = textureW / this.a - 2.0F * uOffs;
    float texH = textureH / this.b - 2.0F * vOffs;
    float segW = texW / segs;
    float segH = texH / rings;
    float startU = this.r / this.a;
    float startV = this.s / this.b;
    int currentFace = 0;
    for (int j = 1; j < rings; j++) {
      PositionTextureVertex[] verts;
      for (int k = 0; k < segs; k++) {
        float yWidth = ls.b(-1.5707964F + 3.1415927F / rings * j);
        float yHeight = ls.a(-1.5707964F + 3.1415927F / rings * j);
        float xSize = ls.a(3.1415927F / segs * k * 2.0F + 3.1415927F) * yWidth;
        float zSize = -ls.b(3.1415927F / segs * k * 2.0F + 3.1415927F) * yWidth;
        int curVert = 1 + k + segs * (j - 1);
        tempVerts[curVert] = new PositionTextureVertex(x + xSize * r, y + yHeight * r, z + zSize * r, 0.0F, 0.0F);
        if (k > 0) {
          PositionTextureVertex[] arrayOfPositionTextureVertex;
          if (j == 1) {
            arrayOfPositionTextureVertex = new PositionTextureVertex[4];
            arrayOfPositionTextureVertex[0] = tempVerts[curVert].setTexturePosition(startU + segW * k, startV + segH * j);
            arrayOfPositionTextureVertex[1] = tempVerts[curVert - 1].setTexturePosition(startU + segW * (k - 1), startV + segH * j);
            arrayOfPositionTextureVertex[2] = tempVerts[0].setTexturePosition(startU + segW * (k - 1), startV);
            arrayOfPositionTextureVertex[3] = tempVerts[0].setTexturePosition(startU + segW + segW * k, startV);
          } else {
            arrayOfPositionTextureVertex = new PositionTextureVertex[4];
            arrayOfPositionTextureVertex[0] = tempVerts[curVert].setTexturePosition(startU + segW * k, startV + segH * j);
            arrayOfPositionTextureVertex[1] = tempVerts[curVert - 1].setTexturePosition(startU + segW * (k - 1), startV + segH * j);
            arrayOfPositionTextureVertex[2] = tempVerts[curVert - 1 - segs].setTexturePosition(startU + segW * (k - 1), startV + segH * (j - 1));
            arrayOfPositionTextureVertex[3] = tempVerts[curVert - segs].setTexturePosition(startU + segW * k, startV + segH * (j - 1));
          } 
          poly[currentFace] = new TexturedPolygon(arrayOfPositionTextureVertex);
          currentFace++;
        } 
      } 
      if (j == 1) {
        verts = new PositionTextureVertex[4];
        verts[0] = tempVerts[1].setTexturePosition(startU + segW * segs, startV + segH * j);
        verts[1] = tempVerts[segs].setTexturePosition(startU + segW * (segs - 1), startV + segH * j);
        verts[2] = tempVerts[0].setTexturePosition(startU + segW * (segs - 1), startV);
        verts[3] = tempVerts[0].setTexturePosition(startU + segW * segs, startV);
      } else {
        verts = new PositionTextureVertex[4];
        verts[0] = tempVerts[1 + segs * (j - 1)].setTexturePosition(startU + texW, startV + segH * j);
        verts[1] = tempVerts[segs * (j - 1) + segs].setTexturePosition(startU + texW - segW, startV + segH * j);
        verts[2] = tempVerts[segs * (j - 1)].setTexturePosition(startU + texW - segW, startV + segH * (j - 1));
        verts[3] = tempVerts[1 + segs * (j - 1) - segs].setTexturePosition(startU + texW, startV + segH * (j - 1));
      } 
      poly[currentFace] = new TexturedPolygon(verts);
      currentFace++;
    } 
    for (int i = 0; i < segs; i++) {
      PositionTextureVertex[] verts = new PositionTextureVertex[3];
      int curVert = tempVerts.length - segs + 1;
      verts[0] = tempVerts[tempVerts.length - 1].setTexturePosition(startU + segW * (i + 0.5F), startV + texH);
      verts[1] = tempVerts[curVert + i].setTexturePosition(startU + segW * i, startV + texH - segH);
      verts[2] = tempVerts[curVert + (i + 1) % segs].setTexturePosition(startU + segW * (i + 1), startV + texH - segH);
      poly[currentFace] = new TexturedPolygon(verts);
      currentFace++;
    } 
    copyTo(tempVerts, poly);
  }
  
  public void addCone(float x, float y, float z, float radius, float length, int segments) {
    addCone(x, y, z, radius, length, segments, 1.0F);
  }
  
  public void addCone(float x, float y, float z, float radius, float length, int segments, float baseScale) {
    addCone(x, y, z, radius, length, segments, baseScale, 4);
  }
  
  public void addCone(float x, float y, float z, float radius, float length, int segments, float baseScale, int baseDirection) {
    addCone(x, y, z, radius, length, segments, baseScale, baseDirection, (int)Math.floor((radius * 2.0F)), (int)Math.floor((radius * 2.0F)));
  }
  
  public void addCone(float x, float y, float z, float radius, float length, int segments, float baseScale, int baseDirection, int textureCircleDiameterW, int textureCircleDiameterH) {
    addCylinder(x, y, z, radius, length, segments, baseScale, 0.0F, baseDirection, textureCircleDiameterW, textureCircleDiameterH, 1);
  }
  
  public void addCylinder(float x, float y, float z, float radius, float length, int segments) {
    addCylinder(x, y, z, radius, length, segments, 1.0F, 1.0F);
  }
  
  public void addCylinder(float x, float y, float z, float radius, float length, int segments, float baseScale, float topScale) {
    addCylinder(x, y, z, radius, length, segments, baseScale, topScale, 4);
  }
  
  public void addCylinder(float x, float y, float z, float radius, float length, int segments, float baseScale, float topScale, int baseDirection) {
    addCylinder(x, y, z, radius, length, segments, baseScale, topScale, baseDirection, (int)Math.floor((radius * 2.0F)), (int)Math.floor((radius * 2.0F)), (int)Math.floor(length));
  }
  
  public void addCylinder(float x, float y, float z, float radius, float length, int segments, float baseScale, float topScale, int baseDirection, int textureCircleDiameterW, int textureCircleDiameterH, int textureH) {
    boolean dirTop = (baseDirection == 4 || baseDirection == 5);
    boolean dirSide = (baseDirection == 3 || baseDirection == 2);
    boolean dirFront = (baseDirection == 0 || baseDirection == 1);
    boolean dirMirror = (baseDirection == 2 || baseDirection == 5 || baseDirection == 1);
    boolean coneBase = (baseScale == 0.0F);
    boolean coneTop = (topScale == 0.0F);
    if (coneBase && coneTop) {
      baseScale = 1.0F;
      coneBase = false;
    } 
    PositionTextureVertex[] tempVerts = new PositionTextureVertex[segments * ((coneBase || coneTop) ? 1 : 2) + 2];
    TexturedPolygon[] poly = new TexturedPolygon[segments * ((coneBase || coneTop) ? 2 : 3)];
    float xLength = dirSide ? length : 0.0F;
    float yLength = dirTop ? length : 0.0F;
    float zLength = dirFront ? length : 0.0F;
    float xStart = dirMirror ? (x + xLength) : x;
    float yStart = dirMirror ? (y + yLength) : y;
    float zStart = dirMirror ? (z + zLength) : z;
    float xEnd = !dirMirror ? (x + xLength) : x;
    float yEnd = !dirMirror ? (y + yLength) : y;
    float zEnd = !dirMirror ? (z + zLength) : z;
    tempVerts[0] = new PositionTextureVertex(xStart, yStart, zStart, 0.0F, 0.0F);
    tempVerts[tempVerts.length - 1] = new PositionTextureVertex(xEnd, yEnd, zEnd, 0.0F, 0.0F);
    float xCur = xStart;
    float yCur = yStart;
    float zCur = zStart;
    float sCur = coneBase ? topScale : baseScale;
    for (int repeat = 0; repeat < ((coneBase || coneTop) ? 1 : 2); repeat++) {
      for (int i = 0; i < segments; i++) {
        float xSize = ((this.i ^ dirMirror) ? -1 : true) * ls.a(3.1415927F / segments * i * 2.0F + 3.1415927F) * radius * sCur;
        float zSize = -ls.b(3.1415927F / segments * i * 2.0F + 3.1415927F) * radius * sCur;
        float xPlace = xCur + (!dirSide ? xSize : 0.0F);
        float yPlace = yCur + (!dirTop ? zSize : 0.0F);
        float zPlace = zCur + (dirSide ? xSize : (dirTop ? zSize : 0.0F));
        tempVerts[1 + i + repeat * segments] = new PositionTextureVertex(xPlace, yPlace, zPlace, 0.0F, 0.0F);
      } 
      xCur = xEnd;
      yCur = yEnd;
      zCur = zEnd;
      sCur = topScale;
    } 
    float uScale = 1.0F / this.a;
    float vScale = 1.0F / this.b;
    float uOffset = uScale / 20.0F;
    float vOffset = vScale / 20.0F;
    float uCircle = textureCircleDiameterW * uScale;
    float vCircle = textureCircleDiameterH * vScale;
    float uWidth = (uCircle * 2.0F - uOffset * 2.0F) / segments;
    float vHeight = textureH * vScale - uOffset * 2.0F;
    float uStart = this.r * uScale;
    float vStart = this.s * vScale;
    for (int index = 0; index < segments; index++) {
      int index2 = (index + 1) % segments;
      float uSize = ls.a(3.1415927F / segments * index * 2.0F + (!dirTop ? 0.0F : 3.1415927F)) * (0.5F * uCircle - 2.0F * uOffset);
      float vSize = ls.b(3.1415927F / segments * index * 2.0F + (!dirTop ? 0.0F : 3.1415927F)) * (0.5F * vCircle - 2.0F * vOffset);
      float uSize1 = ls.a(3.1415927F / segments * index2 * 2.0F + (!dirTop ? 0.0F : 3.1415927F)) * (0.5F * uCircle - 2.0F * uOffset);
      float vSize1 = ls.b(3.1415927F / segments * index2 * 2.0F + (!dirTop ? 0.0F : 3.1415927F)) * (0.5F * vCircle - 2.0F * vOffset);
      PositionTextureVertex[] vert = new PositionTextureVertex[3];
      vert[0] = tempVerts[0].setTexturePosition(uStart + 0.5F * uCircle, vStart + 0.5F * vCircle);
      vert[1] = tempVerts[1 + index2].setTexturePosition(uStart + 0.5F * uCircle + uSize1, vStart + 0.5F * vCircle + vSize1);
      vert[2] = tempVerts[1 + index].setTexturePosition(uStart + 0.5F * uCircle + uSize, vStart + 0.5F * vCircle + vSize);
      poly[index] = new TexturedPolygon(vert);
      if ((this.i ^ this.flip) != 0)
        poly[index].flipFace(); 
      if (!coneBase && !coneTop) {
        vert = new PositionTextureVertex[4];
        vert[0] = tempVerts[1 + index].setTexturePosition(uStart + uOffset + uWidth * index, vStart + vOffset + vCircle);
        vert[1] = tempVerts[1 + index2].setTexturePosition(uStart + uOffset + uWidth * (index + 1), vStart + vOffset + vCircle);
        vert[2] = tempVerts[1 + segments + index2].setTexturePosition(uStart + uOffset + uWidth * (index + 1), vStart + vOffset + vCircle + vHeight);
        vert[3] = tempVerts[1 + segments + index].setTexturePosition(uStart + uOffset + uWidth * index, vStart + vOffset + vCircle + vHeight);
        poly[index + segments] = new TexturedPolygon(vert);
        if ((this.i ^ this.flip) != 0)
          poly[index + segments].flipFace(); 
      } 
      vert = new PositionTextureVertex[3];
      vert[0] = tempVerts[tempVerts.length - 1].setTexturePosition(uStart + 1.5F * uCircle, vStart + 0.5F * vCircle);
      vert[1] = tempVerts[tempVerts.length - 2 - index].setTexturePosition(uStart + 1.5F * uCircle + uSize1, vStart + 0.5F * vCircle + vSize1);
      vert[2] = tempVerts[tempVerts.length - 1 + segments + (segments - index) % segments].setTexturePosition(uStart + 1.5F * uCircle + uSize, vStart + 0.5F * vCircle + vSize);
      poly[poly.length - segments + index] = new TexturedPolygon(vert);
      if ((this.i ^ this.flip) != 0)
        poly[poly.length - segments + index].flipFace(); 
    } 
    copyTo(tempVerts, poly);
  }
  
  public void addObj(String file) {
    addModel(file, ModelPool.OBJ);
  }
  
  public void addModel(String file, Class modelFormat) {
    ModelPoolEntry entry = ModelPool.addFile(file, modelFormat, this.transformGroup, this.textureGroup);
    if (entry == null)
      return; 
    PositionTextureVertex[] verts = (PositionTextureVertex[])Arrays.copyOf((Object[])entry.vertices, entry.vertices.length);
    TexturedPolygon[] poly = Arrays.<TexturedPolygon>copyOf(entry.faces, entry.faces.length);
    if (this.flip)
      for (int l = 0; l < this.faces.length; l++)
        this.faces[l].flipFace();  
    copyTo(verts, poly, false);
  }
  
  public com.adventurer_engine.client.model.tmt.ModelRendererTurbo setTextureOffset(int x, int y) {
    this.r = x;
    this.s = y;
    return this;
  }
  
  public void setPosition(float x, float y, float z) {
    this.c = x;
    this.d = y;
    this.e = z;
  }
  
  public void doMirror(boolean x, boolean y, boolean z) {
    for (TexturedPolygon face : this.faces) {
      PositionTextureVertex[] verts = face.vertexPositions;
      for (PositionTextureVertex vert : verts) {
        vert.a.c *= (x ? -1 : true);
        vert.a.d *= (y ? -1 : true);
        vert.a.e *= (z ? -1 : true);
      } 
      if (x ^ y ^ z)
        face.flipFace(); 
    } 
  }
  
  public void setMirrored(boolean isMirrored) {
    this.i = isMirrored;
  }
  
  public void setFlipped(boolean isFlipped) {
    this.flip = isFlipped;
  }
  
  public void clear() {
    this.vertices = new PositionTextureVertex[0];
    this.faces = new TexturedPolygon[0];
    this.transformGroup.clear();
    this.transformGroup.put("0", new TransformGroupBone(new Bone(0.0F, 0.0F, 0.0F, 0.0F), 1.0D));
    this.currentGroup = this.transformGroup.get("0");
  }
  
  public void copyTo(PositionTextureVertex[] verts, TexturedPolygon[] poly) {
    copyTo(verts, poly, true);
  }
  
  public void copyTo(PositionTextureVertex[] verts, TexturedPolygon[] poly, boolean copyGroup) {
    this.vertices = Arrays.<PositionTextureVertex>copyOf(this.vertices, this.vertices.length + verts.length);
    this.faces = Arrays.<TexturedPolygon>copyOf(this.faces, this.faces.length + poly.length);
    int idx;
    for (idx = 0; idx < verts.length; idx++) {
      this.vertices[this.vertices.length - verts.length + idx] = verts[idx];
      if (copyGroup && verts[idx] instanceof PositionTransformVertex)
        ((PositionTransformVertex)verts[idx]).addGroup(this.currentGroup); 
    } 
    for (idx = 0; idx < poly.length; idx++) {
      this.faces[this.faces.length - poly.length + idx] = poly[idx];
      if (copyGroup)
        this.currentTextureGroup.addPoly(poly[idx]); 
    } 
  }
  
  public void copyTo(PositionTextureVertex[] verts, bbs[] quad) {
    TexturedPolygon[] poly = new TexturedPolygon[quad.length];
    for (int idx = 0; idx < quad.length; idx++)
      poly[idx] = new TexturedPolygon((PositionTextureVertex[])(quad[idx]).a); 
    copyTo(verts, poly);
  }
  
  public void setGroup(String groupName) {
    setGroup(groupName, new Bone(0.0F, 0.0F, 0.0F, 0.0F), 1.0D);
  }
  
  public void setGroup(String groupName, Bone bone, double weight) {
    if (!this.transformGroup.containsKey(groupName))
      this.transformGroup.put(groupName, new TransformGroupBone(bone, weight)); 
    this.currentGroup = this.transformGroup.get(groupName);
  }
  
  public TransformGroup getGroup() {
    return this.currentGroup;
  }
  
  public TransformGroup getGroup(String groupName) {
    if (!this.transformGroup.containsKey(groupName))
      return null; 
    return this.transformGroup.get(groupName);
  }
  
  public void setTextureGroup(String groupName) {
    if (!this.textureGroup.containsKey(groupName))
      this.textureGroup.put(groupName, new TextureGroup()); 
    this.currentTextureGroup = this.textureGroup.get(groupName);
  }
  
  public TextureGroup getTextureGroup() {
    return this.currentTextureGroup;
  }
  
  public TextureGroup getTextureGroup(String groupName) {
    if (!this.textureGroup.containsKey(groupName))
      return null; 
    return this.textureGroup.get(groupName);
  }
  
  public void setGroupTexture(String s) {
    this.currentTextureGroup.texture = s;
  }
  
  public void setDefaultTexture(String s) {
    this.defaultTexture = s;
  }
  
  public void a(float worldScale) {
    if (this.field_1402_i)
      return; 
    if (!this.j)
      return; 
    if (!this.t || this.forcedRecompile)
      d(worldScale); 
    if (this.f != 0.0F || this.g != 0.0F || this.h != 0.0F) {
      GL11.glPushMatrix();
      GL11.glTranslatef(this.c * worldScale, this.d * worldScale, this.e * worldScale);
      if (this.g != 0.0F)
        GL11.glRotatef(this.g * 57.29578F, 0.0F, 1.0F, 0.0F); 
      if (this.h != 0.0F)
        GL11.glRotatef(this.h * 57.29578F, 0.0F, 0.0F, 1.0F); 
      if (this.f != 0.0F)
        GL11.glRotatef(this.f * 57.29578F, 1.0F, 0.0F, 0.0F); 
      callDisplayList();
      if (this.m != null)
        for (Object childModel : this.m)
          ((bcu)childModel).a(worldScale);  
      GL11.glPopMatrix();
    } else if (this.c != 0.0F || this.d != 0.0F || this.e != 0.0F) {
      GL11.glTranslatef(this.c * worldScale, this.d * worldScale, this.e * worldScale);
      callDisplayList();
      if (this.m != null)
        for (Object childModel : this.m)
          ((bcu)childModel).a(worldScale);  
      GL11.glTranslatef(-this.c * worldScale, -this.d * worldScale, -this.e * worldScale);
    } else {
      callDisplayList();
      if (this.m != null)
        for (Object childModel : this.m)
          ((bcu)childModel).a(worldScale);  
    } 
  }
  
  public void b(float f) {
    if (this.field_1402_i)
      return; 
    if (!this.j)
      return; 
    if (!this.t)
      d(f); 
    GL11.glPushMatrix();
    GL11.glTranslatef(this.c * f, this.d * f, this.e * f);
    if (this.g != 0.0F)
      GL11.glRotatef(this.g * 57.29578F, 0.0F, 1.0F, 0.0F); 
    if (this.f != 0.0F)
      GL11.glRotatef(this.f * 57.29578F, 1.0F, 0.0F, 0.0F); 
    if (this.h != 0.0F)
      GL11.glRotatef(this.h * 57.29578F, 0.0F, 0.0F, 1.0F); 
    callDisplayList();
    GL11.glPopMatrix();
  }
  
  public void c(float f) {
    if (this.field_1402_i)
      return; 
    if (!this.j)
      return; 
    if (!this.t || this.forcedRecompile)
      d(f); 
    if (this.f != 0.0F || this.g != 0.0F || this.h != 0.0F) {
      GL11.glTranslatef(this.c * f, this.d * f, this.e * f);
      if (this.h != 0.0F)
        GL11.glRotatef(this.h * 57.29578F, 0.0F, 0.0F, 1.0F); 
      if (this.g != 0.0F)
        GL11.glRotatef(this.g * 57.29578F, 0.0F, 1.0F, 0.0F); 
      if (this.f != 0.0F)
        GL11.glRotatef(this.f * 57.29578F, 1.0F, 0.0F, 0.0F); 
    } else if (this.c != 0.0F || this.d != 0.0F || this.e != 0.0F) {
      GL11.glTranslatef(this.c * f, this.d * f, this.e * f);
    } 
  }
  
  private void callDisplayList() {
    if (this.useLegacyCompiler) {
      GL11.glCallList(this.u);
    } else {
      bim renderEngine = bgl.a.e;
      Collection<TextureGroup> textures = this.textureGroup.values();
      Iterator<TextureGroup> itr = textures.iterator();
      for (int i = 0; itr.hasNext(); i++) {
        TextureGroup curTexGroup = itr.next();
        curTexGroup.loadTexture();
        GL11.glCallList(this.displayListArray[i]);
        if (!this.defaultTexture.equals(""))
          renderEngine.a(new bjo("", this.defaultTexture)); 
      } 
    } 
  }
  
  private void d(float worldScale) {
    if (this.useLegacyCompiler) {
      compileLegacyDisplayList(worldScale);
    } else {
      Collection<TextureGroup> textures = this.textureGroup.values();
      Iterator<TextureGroup> itr = textures.iterator();
      this.displayListArray = new int[this.textureGroup.size()];
      for (int i = 0; itr.hasNext(); i++) {
        this.displayListArray[i] = atu.a(1);
        GL11.glNewList(this.displayListArray[i], 4864);
        TmtTessellator tessellator = TmtTessellator.a;
        TextureGroup usedGroup = itr.next();
        for (int j = 0; j < usedGroup.poly.size(); j++)
          ((TexturedPolygon)usedGroup.poly.get(j)).draw(tessellator, worldScale); 
        GL11.glEndList();
      } 
    } 
    this.t = true;
  }
  
  private void compileLegacyDisplayList(float worldScale) {
    this.u = atu.a(1);
    GL11.glNewList(this.u, 4864);
    TmtTessellator tessellator = TmtTessellator.a;
    for (int i = 0; i < this.faces.length; i++)
      this.faces[i].draw(tessellator, worldScale); 
    GL11.glEndList();
  }
}
